/*	The stage1/stage2 injection code is shamelessly lifted from the PlugSuit
	project. I would have used it, if only the dock would post notifications
	when it launches.. The same goes for the patches that make mach_inject run
	on Leopard.
	
	-daniel
	
	URL: http://millenomi.altervista.org/PlugSuit/
*/

#include "TripleSInject-Stage1.h"
#include <unistd.h>
#include <stdio.h>
#include <dlfcn.h>
#include <limits.h>

void	TripleSInject(void) {
	CFBundleRef		bundle	= CFBundleGetBundleWithIdentifier(CFSTR("no.scsc.TripleS.Loader"));
	CFURLRef		url		= CFBundleCopyResourceURL(bundle, CFSTR("TripleS"), CFSTR("dylib"), NULL);
	CFStringRef		path	= CFURLCopyFileSystemPath(url, kCFURLPOSIXPathStyle);
	char			fsrep[CFStringGetMaximumSizeOfFileSystemRepresentation(path)];
	CFStringGetFileSystemRepresentation(path, fsrep, sizeof(fsrep));
	void			*library	= 0;
	
	library = dlopen(fsrep, RTLD_NOW | RTLD_GLOBAL);
	if (!library) {
		printf("TripleS: dlopen error: %s\n", dlerror());
	}
	else {
		void (*handle)() = dlsym(library, "TripleSInject2");
		if (!handle)
			printf("TripleS: Could not find the stage 2 call symbol: %s\n", dlerror());
		else
			handle();
	}
	CFRelease(path);
	CFRelease(url);
}
